/*
  image_data Ver.1.03 (c)saibara
  
  ۑSpFdirect24imageɈڍs\聦
  
  vs_malloc
  
  Oimage_*
  
  摜f[^߂̃Cu(\̂gȂ摜֌W)
  
  1f̃oCǵuSIZE_PIXELvŒ`B(image_data.h)
  ʏu3vɂ
  pfBOĂȂ̂ŁAtH[}bg(DIB)Ƃ̌݊ɒ
  
  u__windows__v`A
  AbvTCh_E(㉺])tH[}bgOƂB
  
  Ver.1.00 2012/07/31 Ƃ肠쐬
  Ver.1.01 2012/08/23 ϐɂ̂C
  Ver.1.02 2012/11/28 摜(㉺]EE]Ȃ)Tu[`ǉ
  Ver.1.03 2015/05/04 get_image_pointer_nullǉAʊȌ@̈Ⴂ
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "image_data.h"
#include "s_malloc.h"

// wWɑΉsNZl̊i[ꏊւ̃|C^Ԃ
unsigned char *get_image_pointer(unsigned char *buf,int xsize,int ysize,
				 int x_pos,int y_pos)
{
  if(x_pos >= xsize) x_pos = xsize-1;
  if(y_pos >= ysize) y_pos = ysize-1;
  if(x_pos < 0)      x_pos = 0;
  if(y_pos < 0)      y_pos = 0;
#ifdef __windows__
  return(buf + ((ysize - y_pos - 1) * xsize + x_pos ) * SIZE_PIXEL);
#else
  return(buf + (y_pos * xsize+ x_pos) * SIZE_PIXEL);
#endif
}

// wWɑΉsNZl̊i[ꏊւ̃|C^Ԃ(NULL܂)
unsigned char *get_image_pointer_null(unsigned char *buf,int xsize,int ysize,
				      int x_pos,int y_pos)
{
  if(out_of_image_range(x_pos,y_pos,xsize,ysize)) return(NULL);
#ifdef __windows__
  return(buf + ((ysize - y_pos - 1) * xsize + x_pos ) * SIZE_PIXEL);
#else
  return(buf + (y_pos * xsize+ x_pos) * SIZE_PIXEL);
#endif
}

// ㉺]()
void image_change_upsidedown(unsigned char *src,
			     int mx,int my)
{
  int xlen,i;
  unsigned char *d,*e,*buf,temp;
  
  xlen = SIZE_PIXEL * mx;
  e = (unsigned char *)src;
  d = (unsigned char *)src  + xlen * my;
  buf = xalloc(unsigned char,xlen);

  while(d > e)
    {
      d = d - xlen;
      if(buf != NULL)
	{
	  memcpy(buf,e,xlen);
	  memcpy(e,d,xlen);
	  memcpy(d,buf,xlen);
	}
      else
	{
	  for(i=0;i<xlen;i++)
	    {
	      temp = *(e+i);
	      *(e+i) = *(d+i);
	      *(d+i) = temp;
	    }
	}
      e = e + xlen;
    }
  if(buf != NULL) free(buf);
  return; 
}

// ㉺]ȂRs[(ʃ)
void image_copy_upsidedown(unsigned char *dst,unsigned char *src,
			   int mx,int my)
{
  int xlen,y;
  unsigned char *d,*e;
  
  if(dst == src)
    {
      image_change_upsidedown(src,mx,my);
      return;
    }
  xlen = SIZE_PIXEL * mx;
  e = (unsigned char *)dst;
  d = (unsigned char *)src  + xlen * my;
  for(y=0;y<my;y++)
    {
      d = d - xlen;
      memcpy(e,d,xlen);
      e = e + xlen;
    }
  return; 
}

// E]()
void image_change_mirror(unsigned char *src,
			 int mx,int my)
{
  int x,y,xlen,xstep,step;
  unsigned char *d,*e,buf[SIZE_PIXEL];
  
  xstep = SIZE_PIXEL;
  xlen = xstep * mx;
  for(y=0;y<my;y++)
    {
      step = xlen * y;
      for(x=0;x<mx;x++)
	{
	  e = (unsigned char *)src + step + xstep * x;
	  d = (unsigned char *)src + step + xstep * (mx-x-1);
	  memcpy(buf,e,SIZE_PIXEL);
	  memcpy(e,d,SIZE_PIXEL);
	  memcpy(d,buf,SIZE_PIXEL);
	}
    }
}

// E](ʃ)
void image_copy_mirror(unsigned char *dst,unsigned char *src,
		       int mx,int my)
{
  int x,y,xlen,xstep,step;
  unsigned char *d,*e;

  if(dst == src)
    {
      image_change_mirror(src,mx,my);
      return;
    }
  xstep = SIZE_PIXEL;
  xlen = xstep * mx;
  for(y=0;y<my;y++)
    {
      step = xlen * y;
      for(x=0;x<mx;x++)
	{
	  e = (unsigned char *)dst + step + xstep * x;
	  d = (unsigned char *)src + step + xstep * (mx-x-1);
	  memcpy(e,d,SIZE_PIXEL);
	}
    }
  return; 
}
